//********************************************************
//
// Example Application of BRD_xxx functions for QM9857 service.
//
// (C) InSys by Sklyarov A. Oct, 2006
//
//=********************************************************

#include	<conio.h>
#include	<stdio.h>
#include	<tchar.h>
#include	<ctype.h>
#include	<windows.h>
#include	<dos.h>
//#include	<bios.h>

#include	"brd.h"
#include	"ctrlstrm.h"
#include	"CtrlQm9857.h"
#include	"CtrlCmpSC.h"
#define PI2   6.2831853071795864
#define		kSpace	0x3920

const U16 PLD_CFG_TAG	= 0x0500; // tag of PLD
BRD_Handle hQM9857;

ULONG gChanMask = 1;
U32 gNumChans = 1;
S32 gOutputMode=0;
S32 gIsSystemMemory=0;
S32 gSamplesPerChannel= 1024;
U32	gBufSize= 1024;
U32 gOperateMode = 1;
U32 gShift = 0;
U32	gOffsetSampleModFreq;
S32 gAmpModFreq ;
U32	gIsAlwaysLoadPld;
double gModFreq= 1000000.0;
double gSampleRate= 10000000.0;
double gDelta= 0.4;
S32	gMaxNumSamples=32768;	
void DisplayError(S32 status, TCHAR* cmd_str);
S32 PutDataToSrv(BRD_Handle handle, BRD_ServList* srv, int idx);
S32 Qm9857Setings(BRD_Handle handle);
S32 FifoOutputCPU(BRD_Handle handle, PVOID pSig, ULONG bBufSize);
S32 FifoOutputDMA(BRD_Handle handle);
S32 FifoOutputCycleDMA(BRD_Handle handle);
double  CalcSignalParam(double *freq,double samplrate,int *nsamples,int maxNumSamples,int outmode);
S32 CalcSignal(S32 *samples, S32 nsamples,double delta);

//=************************* main *************************
//=********************************************************
void main( int argc, char *argv[] )
{
	S32		status;

	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); //     :     
	
	S32	DevNum;
	status = BRD_init("brd.ini", &DevNum); //  

	//   LID (   )
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_lidList(lidList.pLID, lidList.item, &lidList.itemReal);

	BRD_Info	info;
	info.size = sizeof(info);
	BRD_Handle handle[10];

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		BRD_getInfo(lidList.pLID[iDev], &info); //    
		printf("Board: %s, DevID = 0x%x, RevID = 0x%x, Bus = %d, Dev = %d, Slot = %d.\n", 
			info.name, info.boardType >> 16, info.boardType & 0xff, info.bus, info.dev, info.slot);
		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_EXCLUSIVE, NULL); //     
		if(handle[iDev] > 0)
		{
			BRD_PuList PuList[5];
			U32 ItemReal;
			status = BRD_puList(handle[iDev], PuList, 5, &ItemReal); //    
			if(ItemReal <= 5)
			{
				for(U32 j = 0; j < ItemReal; j++)
				{
					printf("Programable unit %d: %s, Id = %d, Code = %x, Attr = %x.\n",
									j, PuList[j].puDescription, PuList[j].puId, PuList[j].puCode, PuList[j].puAttr);
					if(PuList[j].puCode == PLD_CFG_TAG)
					{ //   
						U32	PldState;

						status = BRD_puState(handle[iDev], PuList[j].puId, &PldState);
						printf("BRD_puState: PldState = %d\n", PldState);

						TCHAR Buffer[128];
						TCHAR iniFilePath[MAX_PATH];
						GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);
						_tcscat_s(iniFilePath, "\\ex_qm9857.ini");
						TCHAR pldFileName[MAX_PATH];
						GetPrivateProfileString("Option", "IsAlwaysLoadPld", "0", Buffer, sizeof(Buffer), iniFilePath);
						gIsAlwaysLoadPld=atoi(Buffer);
						if(PldState==0 || gIsAlwaysLoadPld==1)	//					
						{//  
							printf("BRD_puLoad: loading...\r");
							if(PuList[j].puId == 0x100)
							{
								GetPrivateProfileString("Option", "PldFileName", "ambpcx_v10_admddc4x16_c.mcs", pldFileName, sizeof(pldFileName), iniFilePath);
								status = BRD_puLoad(handle[iDev], PuList[j].puId, pldFileName, &PldState);
							}
							if(BRD_errcmp(status, BRDerr_OK))
								printf("BRD_puLoad: load is OK\n");
							else
								if(BRD_errcmp(status, BRDerr_PLD_TEST_DATA_ERROR))
									printf("BRD_puLoad: data error starting test\n");
								else
									if(BRD_errcmp(status, BRDerr_PLD_TEST_ADDRESS_ERROR))
										printf("BRD_puLoad: address error starting test\n");
									else
										printf("BRD_puLoad: error loading\n");
						}
					}
				}
			}
			BRD_ServList srvList[10];
			status = BRD_serviceList(handle[iDev], 0, srvList, 10, &ItemReal);
			if(ItemReal <= 10)
			{
				for(U32 j = 0; j < ItemReal; j++)
				{
					printf("Service %d: %s, Attr = %X.\n",
									j, srvList[j].name, srvList[j].attr);
				}
			}
			U32 iSrv;
			for(iSrv = 0; iSrv < ItemReal; iSrv++)
			{
				if(!strcmp(srvList[iSrv].name, "QM98570"))
					status = PutDataToSrv(handle[iDev], &srvList[iSrv], iDev * ItemReal + iSrv);
			}
			status = BRD_close(handle[iDev]); //   
			printf("\nBRD_close: OK\n");
		}
	}
	status = BRD_cleanup();
	printf("BRD_cleanup: OK\n");
	printf("Press any key for leaving program...\n");
	_getch();
}

//-------------------------------------------------------------------------
void DisplayError(S32 status, TCHAR* cmd_str)
{
	S32	real_status = BRD_errext(status);
	TCHAR msg[255];
	switch(real_status)
	{
	case BRDerr_OK:
		sprintf_s(msg, "%s: BRDerr_OK\n", cmd_str);
		break;
	case BRDerr_BAD_MODE:
		sprintf_s(msg, "%s: BRDerr_BAD_MODE\n", cmd_str);
		break;
	case BRDerr_INSUFFICIENT_SERVICES:
		sprintf_s(msg, "%s: BRDerr_INSUFFICIENT_SERVICES\n", cmd_str);
		break;
	default:
		sprintf_s(msg, "%s: Unknown error\n", cmd_str);
		break;
	}
	printf(msg);
}

//-------------------------------------------------------------------------
S32 PutDataToSrv(BRD_Handle handle, BRD_ServList* srv, int idx)
{
	S32	status;
	U32 mode = BRDcapt_EXCLUSIVE;

	hQM9857 = BRD_capture(handle, 0, &mode, srv->name, 10000);
	if(mode == BRDcapt_EXCLUSIVE) printf("QM9857 Capture mode: EXCLUSIVE\n");
	if(mode == BRDcapt_SPY)	printf("QM9857 Capture mode: SPY\n");
	if(hQM9857 > 0)
	{
		ULONG master = BRDims_SINGLE; 
		status = BRD_ctrl(hQM9857, 0, BRDctrl_QM_SETMASTER, &master);
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_QM_SETMASTER: master = %d\n", master);
		else
			DisplayError(status, "BRDctrl_QM_SETMASTER");

		status = Qm9857Setings(hQM9857); //   QM9857

		printf("SamplesPerChannel= %d\n",gSamplesPerChannel);
		printf("BufSize= %d byte \n",gBufSize);

	   if(gOperateMode== 1)
	   {
			status = BRD_ctrl(hQM9857, 0, BRDctrl_QM_UPDATEFREQ, &gChanMask);
   	 		printf("\nDDS\n");
			printf("Presss any key for exit\n");
			_getch();
			return 1; 
	   }
		int	nblock=0;

	  if(gOutputMode==0) //------------ One time DMA
	  {
		printf("\nOne time output into QM9857 (DMA)\n");
		BRDctrl_StreamCBufAlloc buf_dscr;
		buf_dscr.dir = BRDstrm_DIR_OUT;
	//	buf_dscr.isCont = 0; //      
		buf_dscr.isCont = gIsSystemMemory; 
		buf_dscr.blkNum = 1;
		buf_dscr.blkSize = gBufSize;
		buf_dscr.ppBlk = new PVOID[buf_dscr.blkNum];
		status = BRD_ctrl(hQM9857, 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr);
		CalcSignal((S32*)buf_dscr.ppBlk[0], gSamplesPerChannel,gDelta);
restart0:
		if(FifoOutputDMA(hQM9857)==1)goto end0;
		nblock++;
		printf("BLOCK %d\n",nblock);

		printf("Presss <Space> for repeat, <ESC> for exit\n");
rst0:	int c=_getch();
        if(c==0x20)goto restart0; // <Space>
        if(c!=0x1B)goto rst0;	//  <!ESC>
end0:	status = BRD_ctrl(hQM9857, 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr);
		delete[] buf_dscr.ppBlk;
	  }
	  if(gOutputMode==1) //-------- One time CPU ------------
	  {
		printf("\nOne time output into QM9857 (CPU)\n");
		int *pSig = new int[gBufSize];
		

		CalcSignal(pSig, gSamplesPerChannel,gDelta);
restart1:
		FifoOutputCPU(hQM9857, pSig, gBufSize );
		nblock++;
		printf("BLOCK %d\n",nblock);

		printf("Presss <Space> for repeat, <ESC> for exit\n");
rst1:	int c=_getch();
        if(c==0x20)goto restart1; // <Space>
        if(c!=0x1B)goto rst1;	//  <!ESC>

		delete pSig;
	  }
	  if(gOutputMode==2) //-------- Cycle DMA ---------------
	  {
		printf("\nCycling output into QM9857 (DMA)\n");
		BRDctrl_StreamCBufAlloc buf_dscr;
		buf_dscr.dir = BRDstrm_DIR_OUT;
	//	buf_dscr.isCont = 0; //      
		buf_dscr.isCont = gIsSystemMemory;
		buf_dscr.blkNum = 1;
		buf_dscr.blkSize = gBufSize;
		buf_dscr.ppBlk = new PVOID[buf_dscr.blkNum];

		status = BRD_ctrl(hQM9857, 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr);

		CalcSignal((S32*)buf_dscr.ppBlk[0], gSamplesPerChannel,gDelta);
		printf("Presss any key for exit\n");
		FifoOutputCycleDMA(hQM9857);
		status = BRD_ctrl(hQM9857, 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr);
		delete[] buf_dscr.ppBlk;
	  }

		
	}
	return status;
}

//   QM9857
//----------------------------------------------------------------------
S32 Qm9857Setings(BRD_Handle handle)
{
	S32		status;
	U32				rcm; 
	U32				nftword ;
	double			dd4G=(double)1024.0*(double)1024.0*(double)4096.0;
	double			WorkClockValue;

	TCHAR Buffer[128];
	TCHAR iniFilePath[MAX_PATH];
	TCHAR* endptr;
	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);
	_tcscat_s(iniFilePath, "\\ex_qm9857.ini");
	GetPrivateProfileString("Option", "OutputMode", "0", Buffer, sizeof(Buffer), iniFilePath);
	gOutputMode=atoi(Buffer);
	GetPrivateProfileString("Option", "SamplesPerChannel", "1024", Buffer, sizeof(Buffer), iniFilePath);
	gSamplesPerChannel=atoi(Buffer);
	GetPrivateProfileString("Option", "IsSystemMemory", "0", Buffer, sizeof(Buffer), iniFilePath);
	gIsSystemMemory=atoi(Buffer);

	GetPrivateProfileString("device_qm98570", "ClockSource", "1", Buffer, sizeof(Buffer), iniFilePath);
	ULONG clock_source = strtol(Buffer, &endptr, 0);
	status = BRD_ctrl(handle, 0, BRDctrl_QM_SETCLKSOURCE, &clock_source);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_QM_SETCLKSOUCE: clock_source = %d\n", clock_source);
	else
			DisplayError(status, "BRDctrl_QM_SETCLKSOUCE");	
	GetPrivateProfileString("device_qm98570", "ChannelMask", "1", Buffer, sizeof(Buffer), iniFilePath);
	gChanMask = strtol(Buffer, &endptr, 0);
	status = BRD_ctrl(handle, 0, BRDctrl_QM_SETCHANMASK, &gChanMask);
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("BRDctrl_QM_SETCHANMASK: gChanMask = %d\n", gChanMask);
		gNumChans=1;
		if(gChanMask==3)gNumChans=2;
	}	
	else
			DisplayError(status, "BRDctrl_QM_SETCHANMASK");
		//------ Set Main Params ---------------------
		BRD_QmSetMainParam  mainParam;

		mainParam.progMask = 3;
		mainParam.pllLock = 1;
		mainParam.clockMult = 1;
		mainParam.cicClear = 0;
		mainParam.invSincBypass = 0;
		mainParam.fullSleep = 0;
		mainParam.autoPowerDown = 0;
		mainParam.operatingMode = 1;

   //-------- Set Profile ------------------------
		BRD_QmSetProfile		qmSetProfile;

		qmSetProfile.progMask = 3;
		qmSetProfile.profNum = 0;
		qmSetProfile.freqNco = 0;
		qmSetProfile.cicRate = 4;
		qmSetProfile.spectrInv = 0;
		qmSetProfile.invCicBypass = 0;
		qmSetProfile.outputScale = 180;

   //-------- Set StartMode ------------------------
		BRD_StartMode  startMode;
		
		startMode.startSrc= 0;
		startMode.startInv= 0;
		startMode.trigOn= 0;
		startMode.trigStopSrc= 0;
		startMode.stopInv= 0;
		startMode.reStartMode=0;


	GetPrivateProfileString("device_qm98570", "ClockValue", "200000000", Buffer, sizeof(Buffer), iniFilePath);
	ULONG clock_value = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "OperateMode", "1", Buffer, sizeof(Buffer), iniFilePath);
	gOperateMode = atoi(Buffer);
	mainParam.operatingMode = gOperateMode;
	GetPrivateProfileString("device_qm98570", "CarFreq", "50000000", Buffer, sizeof(Buffer), iniFilePath);
	ULONG car_freq = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "ModFreq", "10000000", Buffer, sizeof(Buffer), iniFilePath);
	ULONG mod_freq = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "OutSclFactor", "180", Buffer, sizeof(Buffer), iniFilePath);
	qmSetProfile.outputScale = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "AmpModFreq", "8000", Buffer, sizeof(Buffer), iniFilePath);
	gAmpModFreq = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "OffsetSampleModFreq", "0", Buffer, sizeof(Buffer), iniFilePath);
	gOffsetSampleModFreq = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "PLLLock", "1", Buffer, sizeof(Buffer), iniFilePath);
	mainParam.pllLock = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "RefClkMult", "1", Buffer, sizeof(Buffer), iniFilePath);
	mainParam.clockMult = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "InvSincBypass", "0", Buffer, sizeof(Buffer), iniFilePath);
	mainParam.invSincBypass = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "SpectralInv", "0", Buffer, sizeof(Buffer), iniFilePath);
	qmSetProfile.spectrInv = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "InvCicBypass", "0", Buffer, sizeof(Buffer), iniFilePath);
	qmSetProfile.invCicBypass = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "CicInterRate", "2", Buffer, sizeof(Buffer), iniFilePath);
	qmSetProfile.cicRate = atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "StartSource", "0", Buffer, sizeof(Buffer), iniFilePath);
	startMode.startSrc= atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "StartInverting", "0", Buffer, sizeof(Buffer), iniFilePath);
	startMode.startInv= atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "StartTrigger", "0", Buffer, sizeof(Buffer), iniFilePath);
	startMode.trigOn= atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "StopSource", "0", Buffer, sizeof(Buffer), iniFilePath);
	startMode.trigStopSrc= atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "StopInverting", "0", Buffer, sizeof(Buffer), iniFilePath);
	startMode.stopInv= atoi(Buffer);
	GetPrivateProfileString("device_qm98570", "RefVoltageComp1", "0", Buffer, sizeof(Buffer), iniFilePath);
	float refVoltageComp1= atof(Buffer);
	rcm = mainParam.clockMult;
	if(rcm<4)rcm = 1;
	else if(rcm>20) rcm = 20;
	nftword = (U32)( ( ( (double)dd4G/(double)rcm ) *(double)(car_freq) )/(double)(clock_value) );
	WorkClockValue=(double)clock_value*rcm;
    gSampleRate=WorkClockValue/(4*qmSetProfile.cicRate);

	gModFreq= (double)mod_freq;
	gDelta=CalcSignalParam(&gModFreq,gSampleRate,&gSamplesPerChannel,gMaxNumSamples,gOutputMode);

	gBufSize=gSamplesPerChannel*4;
	gBufSize *=gNumChans;
	if(gOperateMode==2)	//  
				gBufSize /=2;

	
	status = BRD_ctrl(handle, 0, BRDctrl_QM_QMRESET, NULL);

	qmSetProfile.freqNco = nftword;


	status = BRD_ctrl(handle, 0, BRDctrl_QM_SETMAINPARAM, &mainParam);
	status = BRD_ctrl(handle, 0, BRDctrl_QM_SETPROFILE, &qmSetProfile);
	status = BRD_ctrl(handle, 0, BRDctrl_QM_SETSTARTMODE, &startMode);
	
	BRD_CmpSC cmp_sc;
	cmp_sc.src= 0;
	cmp_sc.thr[0]=refVoltageComp1;
	cmp_sc.thr[1]=refVoltageComp1;
	status = BRD_ctrl(handle, 0, BRDctrl_CMPSC_SET, &cmp_sc);

	return status;
}

//         FIFO
//----------------------------------------------------------------------
S32 FifoOutputCPU(BRD_Handle handle, PVOID pSig, ULONG bBufSize)
{
	
	S32		status;
	ULONG Status = 0;

	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFORESET, NULL); //  FIFO 
	BRD_DataBuf data_buf;
	data_buf.pData = pSig;
	data_buf.size = bBufSize;
	status = BRD_ctrl(handle, 0, BRDctrl_QM_PUTDATA, &data_buf);
	status = BRD_ctrl(handle, 0, BRDctrl_QM_START, NULL); //   
	U32		statusFIFO=0x4;
    while((statusFIFO & (1<<2))==(1<<2))//      FIFO  QM9857 
    {
	       status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFOSTATUS, &statusFIFO); 
    }

	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   
	return status;

}

#include	<math.h>
#define TWO_PI (8.0*atan(1.0))

//       -   
//----------------------------------------------------------------------
S32 FifoOutputDMA(BRD_Handle handle)
{

	S32		status;
	ULONG Status = 0;
	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFORESET, NULL); //  FIFO 


	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 0; //   
	status = BRD_ctrl(handle, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_START, NULL); //   
	int fl_break = 0;

	ULONG msTimeout = 20000; //       20 .
	status = BRD_ctrl(handle, 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
	if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	{	//   -
		printf("\nTIME-OUT! \n");
		fl_break = 1;
	}
	U32		statusFIFO=0x4;
    while((statusFIFO & (1<<2))==(1<<2))//      FIFO  QM9857 
    {
	       status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFOSTATUS, &statusFIFO); 
    }

	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   

	return fl_break;

}

//       -   
//----------------------------------------------------------------------
S32 FifoOutputCycleDMA(BRD_Handle handle)
{

	S32		status;
	ULONG Status = 0;

	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFORESET, NULL); //  FIFO 

	status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFOSTATUS, &Status);

	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 1; //  
	status = BRD_ctrl(handle, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_START, NULL); //   
	int fl_break = 0;
	ULONG msTimeout = 20000; //       20 .
	int	nblock=0;
	while(!_kbhit())
	{
		status = BRD_ctrl(handle, 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
		if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
		{	//   -
			printf("\nTIME-OUT! \n");
			status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   
			return 1;
		}
		nblock++;
		printf("\rBLOCK %d",nblock);
	}
	_getch();
	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   

	return 0;

}
//=******************** Calculate of signal param ****************************
//---------------------------------------------------------------------------
double  CalcSignalParam(double *freq,double samplrate,int *nsamples,int maxNumSamples,int outmode)
{
    double fr=*freq;
    int    ns=*nsamples;
    double sr=samplrate;
    double dfr;
    double dt;
    double mindfr=100000000;
    int    minn;
    int    mink;
    int k,n;
	if(outmode<2)return PI2*(fr/sr);


    for(n=1024;n<maxNumSamples;n +=64)
//    for(n=256;n<4096; n +=64)
    {
        for(k=1;k<=n/2;k++)
        {
          dfr=fabs(fr-k*sr/n);
          if(dfr<mindfr)
          {
            mindfr=dfr;
            minn=n;
            mink=k;
          }
        }
    }

    fr=mink*sr/minn;
    dt=PI2*mink/minn;
    *freq=fr;
    // !!!!!!!!!!!!!!!!!
    k=maxNumSamples/minn;
    k=2;
    minn=k*minn;
    // !!!!!!!!!!!!!!!!!
    *nsamples=minn;
    return dt;

}
//-----------------------------------------------------------------------
//=******************** Calculate of signal  ****************************
//-----------------------------------------------------------------------

S32 CalcSignal(S32 *samples, S32 nsamples,double delta)
{
//    double delta=PI2*(gModFreq/gSampleRate);
	S32 Is,Qs;

	if(gOperateMode==0) //------------- 
	{
		if(gNumChans==1)
		{
			for(int i=0;i<nsamples;i++)
			{
				Is=(S32)(gAmpModFreq*cos(i*delta))+gOffsetSampleModFreq;
				Qs=(S32)(-gAmpModFreq*sin(i*delta))+gOffsetSampleModFreq;
				samples[i]=(0xffff & Is<<2) | (0xfffc0000 & Qs<<18);
	        }
			if(gOutputMode!=2)
			{
				samples[nsamples-2 ]=0;  
				samples[nsamples-1]=0;
			}
		}
		if(gNumChans==2)
		{
			for(int i=0;i<nsamples;i++)
			{
				Is=(S32)(gAmpModFreq*cos(i*delta))+gOffsetSampleModFreq;
				Qs=(S32)(-gAmpModFreq*sin(i*delta))+gOffsetSampleModFreq;
				samples[2*i]=(0xffff & Is<<2) | (0xfffc0000 & Is<<18);
				samples[2*i+1]=(0xffff & Qs<<2) | (0xfffc0000 & Qs<<18);
	        }
			if(gOutputMode!=2)
			{
				samples[nsamples-2 ]=0;  
				samples[nsamples-1]=0;
			}

		}

	}
	if(gOperateMode==2) //----------------  
	{
		if(gNumChans==1)
		{
			for(int i=0;i<nsamples/2;i++)
			{
				Is=(S32)(gAmpModFreq*sin((2*i)*delta))+gOffsetSampleModFreq;
				Qs=(S32)(gAmpModFreq*sin((2*i+1)*delta))+gOffsetSampleModFreq;
				samples[i]=(0xffff & Is<<2) | (0xfffc0000 & Qs<<18);
	        }
		}
		if(gNumChans==2)
		{
			for(int i=0;i<nsamples/2;i++)
			{
				Is=(S32)(gAmpModFreq*sin((2*i)*delta))+gOffsetSampleModFreq;
				Qs=(S32)(gAmpModFreq*sin((2*i+1)*delta))+gOffsetSampleModFreq;
				samples[2*i]=(0xffff & Is<<2) | (0xfffc0000 & Is<<18);
				samples[2*i+1]=(0xffff & Qs<<2) | (0xfffc0000 & Qs<<18);
	        }
		}


	}

return 1;
}
//----------------------------------------------------------------------

//
// End of file
//
